import { Application } from '@nativescript/core';
var VNDocumentCameraViewControllerDelegateImpl = /** @class */ (function (_super) {
    __extends(VNDocumentCameraViewControllerDelegateImpl, _super);
    function VNDocumentCameraViewControllerDelegateImpl() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    VNDocumentCameraViewControllerDelegateImpl.initWithResolveReject = function (resolve, reject) {
        var delegate = VNDocumentCameraViewControllerDelegateImpl.new();
        delegate.resolve = resolve;
        delegate.reject = reject;
        return delegate;
    };
    VNDocumentCameraViewControllerDelegateImpl.prototype.documentCameraViewControllerDidCancel = function (controller) {
        var _a;
        (_a = this.reject) === null || _a === void 0 ? void 0 : _a.call(this);
        controller.dismissViewControllerAnimatedCompletion(true, null);
    };
    VNDocumentCameraViewControllerDelegateImpl.prototype.documentCameraViewControllerDidFailWithError = function (controller, error) {
        var _a;
        (_a = this.reject) === null || _a === void 0 ? void 0 : _a.call(this, error);
        controller.dismissViewControllerAnimatedCompletion(true, null);
    };
    VNDocumentCameraViewControllerDelegateImpl.prototype.documentCameraViewControllerDidFinishWithScan = function (controller, scan) {
        var _a;
        var result = [];
        for (var index = 0; index < scan.pageCount; index++) {
            result.push(scan.imageOfPageAtIndex(index));
        }
        (_a = this.resolve) === null || _a === void 0 ? void 0 : _a.call(this, result);
        controller.dismissViewControllerAnimatedCompletion(true, null);
    };
    VNDocumentCameraViewControllerDelegateImpl.ObjCProtocols = [VNDocumentCameraViewControllerDelegate];
    return VNDocumentCameraViewControllerDelegateImpl;
}(NSObject));
export class DocumentScanner {
    constructor(options) {
        this.options = options;
    }
    async startScan() {
        let controller;
        let delegate;
        try {
            const result = await new Promise((resolve, reject) => {
                try {
                    if (!VNDocumentCameraViewController.supported) {
                        throw new Error('VisionKit not supported on this device');
                    }
                    controller = VNDocumentCameraViewController.new();
                    delegate = controller.delegate = VNDocumentCameraViewControllerDelegateImpl.initWithResolveReject(resolve, reject);
                    Application.ios.rootController.presentViewControllerAnimatedCompletion(controller, true, null);
                    this.resolve = resolve;
                    this.reject = reject;
                }
                catch (error) {
                    reject(error);
                }
            });
            return result;
        }
        catch (error) {
            throw error;
        }
        finally {
            controller.delegate = null;
            controller = null;
            delegate = null;
        }
    }
    clean() { }
}
//# sourceMappingURL=index.ios.js.map